
package de.ivu.elect.presentation.email.table;

import de.ivu.elect.business.email.entity.Email;
import de.ivu.elect.jee.presentation.dynamictable.AbstractColumnBuilder;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;
import de.ivu.elect.presentation.person.PersonendatenFormatter;
import de.ivu.elect.presentation.person.table.AbstractPersonendatenColumn;
import de.ivu.elect.presentation.person.table.PersonendatenRufnameAnzeigeColumn;

import javax.inject.Inject;
import javax.inject.Named;
import java.util.ArrayList;
import java.util.List;

@Named(EmailColumnBuilder.COMPONENT_NAME)
public class EmailColumnBuilder extends AbstractColumnBuilder<Email> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailColumnBuilder";

  @Inject
  private transient PersonendatenFormatter personendatenFormatter;

  private AbstractEmailColumn<Email> emailStatusColumn;
  private AbstractEmailColumn<Email> emailAnhaengeColumn;
  private AbstractEmailColumn<Email> emailEmpfaengerColumn;
  private AbstractEmailColumn<Email> emailPersonendatenFamiliennameColumn;
  private AbstractEmailColumn<Email> emailPersonendatenRufnameColumn;
  private AbstractEmailColumn<Email> emailFehlermeldungColumn;
  private AbstractEmailColumn<Email> emailAnzahlSendeversucheColumn;
  private AbstractEmailColumn<Email> emailLetzterSendeversuchColumn;


  public EmailColumnBuilder() {
    super();
  }

  @Override
  protected void initColumns() {
    emailStatusColumn = new EmailStatusColumn<>(getMessages(), getIcons());
    emailAnhaengeColumn = new EmailAnhaengeColumn<>(getMessages(), getIcons());
    emailEmpfaengerColumn = new EmailEmpfaengerColumn<>(getMessages());
    emailPersonendatenFamiliennameColumn = new EmailPersonendatenColumn(getMessages(),
        AbstractPersonendatenColumn.createPersonendatenFamiliennameColumn(getMessages()));
    emailPersonendatenRufnameColumn = new EmailPersonendatenColumn(getMessages(),
        new PersonendatenRufnameAnzeigeColumn<>(getMessages(), personendatenFormatter));
    emailFehlermeldungColumn = AbstractEmailColumn.createEmailFehlermeldungColumn(getMessages());
    emailAnzahlSendeversucheColumn = AbstractEmailColumn.createEmailAnzahlSendeversucheColumn(getMessages());
    emailLetzterSendeversuchColumn = AbstractEmailColumn.createEmailLetzterSendeversuchColumn(getMessages());
  }

  @Override
  protected List<ColumnEntry< ? super Email>> getColumnEntriesSorted() {
    List<ColumnEntry< ? super Email>> result = new ArrayList<>();

    result.add(emailStatusColumn);
    result.add(emailAnhaengeColumn);
    result.add(emailEmpfaengerColumn);
    result.add(emailPersonendatenFamiliennameColumn);
    result.add(emailPersonendatenRufnameColumn);
    result.add(emailFehlermeldungColumn);
    result.add(emailAnzahlSendeversucheColumn);
    result.add(emailLetzterSendeversuchColumn);

    return result;
  }
}
